(function($) {
    $.fn.multiCheck = function(options) {
    	var isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
    	if(!options) options = {};
    	return this.each(function() {
    		var app = {
				ready:function(t){
					var self = this;
					$(".drop-button").off( "click");
					$(".drop-button").click(function(){
						var p = $(this).parent();
						$(".multi-check").each(function(){
							if($(this).attr("id")!=$(p).attr("id")) self.close(this);
						});
						if($(this).hasClass("active")) {
							$(p).find(".drop,.drop-button").removeClass("active");
						} else {
							$(p).find(".drop,.drop-button").addClass("active");
						}
					});
					$(window).on("mousedown", function(){
						
						if($(event.target).hasClass("drop-button")) return false;
						
						$(".drop-button").each(function(){
							if($(this).hasClass("active")) {
								var cl = $(event.target).hasClass("drop");
								var clb = $(event.target).hasClass("drop-button");
								var pcl = $(event.target).parent().hasClass("drop");
								var ppcl = $(event.target).parent().parent().hasClass("drop");
								if(!clb && !cl && !pcl && !ppcl) {
									$(this).trigger("click");
								}
							} 
						})
					});
					$(container).find("input[type='checkbox']").change(function(){
						self.change(this);
					});
					$(container).find("li").click(function(){
						self.changeSingle(this);
					});
				},
				
				change:function(t){
					var val = $(t).prop("checked");
					var option = $(select).find("option[value='"+$(t).val()+"']");
					$(option).prop("selected",val);
					$(option).trigger("mousedown")
					$(select).trigger("change");
					count = $(select).val().length;
					var placehold = (count>0) ? label+" ("+count+")" : label;
					$(container).find(".drop-button").html(placehold);
				},
				changeSingle:function(t){
					$(select).val($(t).attr("value"));
					$(container).find(".drop-button").html($(t).html());
					$(t).parent().find("li.checked").removeClass("checked");
					$(t).addClass("checked");
					this.close($(t).parent().parent().parent());
				},
				close:function(t){
					$(t).find(".drop,.drop-button").removeClass("active");
				}
			}
			
			
    		var id = Math.random().toString(36).substring(4);
    		var select = $(this);
    		var list = [];
			var h = "";
			var label = "Choose Options";
			var count = $(select).val().length;
			var mode = $(this).prop('multiple');
			
			if(mode){
				if($(select).find("optgroup").length) {
					$(select).find("optgroup").each(function(){
						h+="<p>"+$(this).attr('label')+"</p>";
						$(this).find("option").each(function(){
							var checked = ($(this).prop("selected")) ? "checked" : "";
							h+="<label><input type='checkbox' data-name='"+$(this).val()+"' value='"+$(this).val()+"' "+checked+"/> "+$(this).html()+"</label>";
						});
					});
				} else {
					$(select).find("option").each(function(i,o){
						var checked = ($(this).prop("selected")) ? "checked" : "";
						h+="<label><input type='checkbox' data-name='"+$(this).val()+"' value='"+$(this).val()+"' "+checked+"/> "+$(this).html()+"</label>";
					});
				}
				if($(select).attr("placeholder") && $(select).attr("placeholder")!="") label = $(select).attr("placeholder");
				var placehold = (count>0) ? label+" ("+count+")" : label;
				$(select).after("<div class='multi-check' id='select-"+id+"'><a class='drop-button'>"+placehold+"</a><div class='drop'>"+h+"</div></div>");
			
			} else {
			    h+="<ul>";
				$(select).find("option").each(function(i,o){
						var checked = ($(this).prop("selected")) ? "checked" : "";
						if(checked) placehold = $(this).html();
						h+="<li value='"+$(this).val()+"' class='"+checked+"'> "+$(this).html()+"</li>";
					});
				h+="</ul>";
				$(select).after("<div class='multi-check multi-single' id='select-"+id+"'><a class='drop-button'>"+placehold+"</a><div class='drop'>"+h+"</div></div>");
			
			}
			$(select).hide();
			var container = $("#select-"+id);
    		app.ready();
    		
   		 });
    }
})(jQuery);